#------------------------------------------------------#
# Tur-Invite. A blatant ripoff from Dark0n3 =)         #
# Ripoff Version: 1.4                                  #
# Made by ripoff by Turranius, tcl magic by S3x and    #
# subzero !                                            #
#                                                      #
#-[ Intro and installation ]---------------------------#
#                                                      #
# Right then. I wanted a invite bot only without the   #
# full dZSbot.tcl package so I took out the parts      #
# needed only for '/msg bot !invite user pw'.          #
#                                                      #
# It does not handle 'site invite' from inside ftp.    #
#                                                      #
# I added, with the help of s3x, some more announce    #
# lines for it the user is deleted and/or purged.      #
# So you cant invite yourself anymore if you are       #
# deleted on site (flag 6).                            #
#                                                      #
# subzero also added more functionality, namely invite #
# to other chans based on the group you are in. More   #
# on this below                                        #
#                                                      #
# In 1.4, subzero also added functions for inviting to #
# different chans based on argument.                   #
# For instance, !invite user pass staffchan            #
#                                                      #
# You may update your current dZSbot.tcl with these    #
# functions by copying the 'set announce' for          #
# DELMSGINVITE and NOMSGINVITE.                        #
# If you are too lazy to do that but still want this   #
# functionality, just load it after dZSbot.tcl in your #
# eggdrops config file.                                #
#                                                      #
# Also grab and overwrite the entire INVITE CHECK      #
# part.                                                #
#                                                      #
# However, if you want this on a standalone bot for    #
# invites only, edit the settings below. If you do not #
# have passchk already, compile the passchk.c with     #
# gcc -o passchk passchk.c                             #
#                                                      #
# Make sure all paths below are correct.               #
#                                                      #
# If you dont want it to say anything in the announce, #
# set that announce to ""                              #
#                                                      #
# Load it in your bots config file.                    #
#                                                      #
#-[ 1.3 ]----------------------------------------------#
#                                                      #
# New in 1.3 is: set chanlist(GROUP-STAFF) "#chan"     #
# It must be prefixed with GROUP-                      #
# That means that if you are in the group STAFF, you   #
# will also be invited to the #chan channel as well    #
# as the DEFAULT channel when doing a normal !invite.  #
#                                                      #
# As you can see from the example, you can also add a  #
# custom invite message for the channels you define    #
# here, so if we use the above example, we get:        #
# set announce(#chan)        "-sitename- blabla"       #
#                                                      #
# will be announced in the #chan channel when a user   #
# in the group STAFF invites himself.                  #
# (note that its the channel you set as announce, not  #
# group).                                              #
#                                                      #
#-[ 1.4 ]----------------------------------------------#
#                                                      #
# New in 1.4 is: set chanlist(MP3) "#mymp3chan"        #
#                                                      #
# This meaning that issuing !invite user pass mp3      #
# will invite the user to the #mymp3chan only.         #
#                                                      #
# This one always uses announce(DEFAULT)               #
#                                                      #
#-[ Note on upgrading from 1.3 to 1.4 ]----------------#
#                                                      #
# Note that special group invites must now be prefixed #
# with GROUP- instead of just the groupname. See 1.3   #
# section above.                                       #
#                                                      #
#-[ Contact ]------------------------------------------#
#                                                      #
# Not much support is available for this one, but...   #
# http://www.grandis.nu/glftpd                         #
# http://grandis.mine.nu                               #
# Turranius / S3X / subzero - 2003.                    #
#                                                      #
#-[ Settings ]-----------------------------------------#

## Basic settings.
set binary(PASSCHK)   "/bin/passchk"
set location(PASSWD)  "/glftpd/etc/passwd"
set location(USERS)   "/glftpd/ftp-data/users/"
set binary(CAT)       "/bin/cat"

## Char you use to prefix commands.
set cmdprefix         "!"

## Default invite chan (no args given)
set chanlist(DEFAULT) "#xXx"

## User specified !invite user pass mp3
set chanlist(MP3)     "#xXx-MP3"

## User is in group STAFF
set chanlist(GROUP-STAFF)   "#xXx-STAFF"

## Your sitename.
set sitename          "xXx"

## Invite messages, default.
set announce(MSGINVITE)    "-%sitename- \[INVITE\] + %bold%user%bold@%group rides again as %bold%ircnick%bold"
set announce(BADMSGINVITE) "-%sitename- \[INTRUDER\] - %bold%ircnick%bold (%host) tried to invite himself with invalid login!"
set announce(DELMSGINVITE) "-%sitename- \[INTRUDER\] - %bold%ircnick%bold (%host) tried to invite himself but %ircnick is deleted!"
set announce(NOMSGINVITE)  "-%sitename- \[INTRUDER\] - %bold%ircnick%bold (%host) tried to invite himself but there is no such user!"

## Special invite for #xXx-STAFF if the user is in group STAFF
set announce(#xXx-STAFF)   "-%sitename- %bold%user%bold joined the discussion as %bold%ircnick%bold"

## Word to react on. 
bind msg -|- [set cmdprefix]invite invite

## No need to change.
set splitter(CHAR) "\n"


#################################################################################
# REPLACE WHAT WITH WITHWHAT                                                    #
#################################################################################
proc replacevar {strin what withwhat} {
 global zeroconvert

 set output $strin
 set replacement $withwhat

    if { [string length $replacement] == 0 && [info exists zeroconvert($what)] } { set replacement $zeroconvert($what) }
 set cutpos 0

    while { [string first $what $output] != -1 } {
	set cutstart [expr [string first $what $output] - 1]
	set cutstop  [expr $cutstart + [string length $what] + 1]
	set output [string range $output 0 $cutstart]$replacement[string range $output $cutstop end]
    }
 return $output
}
#################################################################################


#################################################################################
# CONVERT BASIC COOKIES TO DATA                                                 #
#################################################################################
proc basicreplace {strin section} {
 global sitename

    set output [replacevar $strin "%sitename" $sitename]
    set output [replacevar $output "%bold" "\002"]
    set output [replacevar $output "%uline" "\037"]
    set output [replacevar $output "%section" $section]
 return "$output"
}
#################################################################################


#################################################################################
# INVITE CHECK  Modified by Turranius/S3X/subzero                               #
#################################################################################
proc invite { nick host hand arg } {
 global location binary chanlist announce

 if { [llength $arg] >= 2 } {
  set username [lindex $arg 0]
  set password [lindex $arg 1]
  set result [exec $binary(PASSCHK) $username $password $location(PASSWD)]
  set group ""

  set userfile "$location(USERS)$username"

  if {![file exists $userfile]} then {
    set output $announce(NOMSGINVITE)
  } else {
    foreach line [split [exec $binary(CAT) $userfile] "\n"] {
      if { ! [string compare [lindex $line 0] "FLAGS"] } {
	set flags [lindex $line 1]
        break
      }
    }

    if { [string match "*6*" "$flags"] != "0" } { set result "DELLED" }

    if { ! [string compare $result "MATCH"] } {
      set output $announce(MSGINVITE)
	foreach line [split [exec $binary(CAT) $userfile] "\n"] {
	  if { ! [string compare [lindex $line 0] "GROUP"] } {
	    set group [lrange $line 1 end]
            break
	  }
	}
	if { [lindex $arg 2] == "" } {
          foreach channel $chanlist(DEFAULT) { puthelp "INVITE $nick $channel" }
        }
	if { [lindex $arg 2] != "" } {
	  foreach channel [array get chanlist] {
	    if { [string match "*group-*" "[string tolower [lindex $arg 3]]"] } { break }
	    if { [string match "[string tolower [lindex $arg 2]]" "[string tolower $channel]"] } {
              puthelp "INVITE $nick $chanlist($channel)"
              set output2 $announce(MSGINVITE)
              set output2 [replacevar "$output2" "%ircnick" $nick]
              set output2 [replacevar "$output2" "%user" $username]
              set output2 [replacevar "$output2" "%host" $host]
              set output2 [replacevar "$output2" "%group" $group]
              set output2 [basicreplace "$output2" "INVITE"]
              sndall "$channel" "$output2"
	    }
	  }
	}
	foreach grp $group {
          if { [info exists chanlist(GROUP-$grp)] } {
	    foreach channel $chanlist(GROUP-$grp) {
	      puthelp "INVITE $nick $channel"
	      if { [info exists announce($channel)] } {
                set output3 $announce($channel)
                set output3 [replacevar "$output3" "%ircnick" $nick]
                set output3 [replacevar "$output3" "%user" $username]
                set output3 [replacevar "$output3" "%host" $host]
                set output3 [replacevar "$output3" "%group" $group]
                set output3 [basicreplace "$output3" "INVITE"]
                sndall "GROUP-$grp" "$output3"
	      }
	    }
	  }
	}
    } else { if { ! [string compare $result "NOMATCH"] } {
      set output $announce(BADMSGINVITE)
    } else { if { ! [string compare $result "DELLED"] } {
      set output $announce(DELMSGINVITE)
    } else {
      set output $announce(BADMSGINVITE)
    }
    }
    }
  }

  if { [lindex $arg 2] == "" } {
    set output [replacevar "$output" "%ircnick" $nick]
    set output [replacevar "$output" "%user" $username]
    set output [replacevar "$output" "%host" $host]
    set output [replacevar "$output" "%group" $group]
    set output [basicreplace "$output" "INVITE"]
    sndall "DEFAULT" "$output"
  }
 }
}

#################################################################################
# SEND TO ALL CHANNELS LISTED                                                   #
#################################################################################
proc sndall {section args} {
 global chanlist splitter
 foreach chan $chanlist($section) {
  foreach line [split [lindex $args 0] $splitter(CHAR)] {
   putquick "PRIVMSG $chan :$line"
  }
 }
}
#################################################################################


putlog "Invite 1.4 by Turranius (Based on Dark0n3's sitebot) loaded"
